@use "../sable";

$blurBreakpoints: (
  'none': 0,
  'xs': 2px,
  'sm': 4px,
  'def': 8px,
  'md': 12px,
  'lg': 16px,
  'xl': 24px,
  '2xl': 40px,
  '3xl': 64px,
) !default;

@each $bpName, $value in $blurBreakpoints {
  $subName: '';
  @if ($bpName != 'def') {
    $subName: '-' + $bpName;
  }

  .blur#{$subName},
  .focus\:blur#{$subName}:focus,
  .hover\:blur#{$subName}:hover {
    @include sable.filter-blur($value);
  }

  .backdrop-blur#{$subName},
  .focus\:backdrop-blur#{$subName}:focus,
  .hover\:backdrop-blur#{$subName}:hover {
    @include sable.filter-backdrop-blur($value);
  }
}

$brightnesses: (
  0,
  .5,
  .75,
  .9,
  .95,
  1,
  1.05,
  1.1,
  1.25,
  1.5,
  2,
) !default;

@each $value in $brightnesses {
  $number: $value * 100;
  .brightness-#{$number},
  .focus\:brightness-#{$number}:focus,
  .hover\:brightness-#{$number}:hover {
    @include sable.filter-brightness($value);
  }
  
  .backdrop-brightness-#{$number},
  .focus\:backdrop-brightness-#{$number}:focus,
  .hover\:backdrop-brightness-#{$number}:hover {
    @include sable.filter-backdrop-brightness($value);
  }
}

$contrasts: (
  0,
  .5,
  .75,
  1,
  1.25,
  1.5,
  2,
) !default;

@each $value in $contrasts {
  $number: $value * 100;
  .contrast-#{$number},
  .focus\:contrast-#{$number}:focus,
  .hover\:contrast-#{$number}:hover {
    @include sable.filter-contrast($value);
  }
  
  .backdrop-contrast-#{$number},
  .focus\:backdrop-contrast-#{$number}:focus,
  .hover\:backdrop-contrast-#{$number}:hover {
    @include sable.filter-backdrop-contrast($value);
  }
}

.grayscale-0,
.focus\:grayscale-0:focus,
.hover\:grayscale-0:hover {
  @include sable.filter-grayscale(0);
}
.grayscale,
.focus\:grayscale:focus,
.hover\:grayscale:hover{
  @include sable.filter-grayscale(100%);
}

.backdrop-grayscale-0,
.focus\:backdrop-grayscale-0:focus,
.hover\:backdrop-grayscale-0:hover {
  @include sable.filter-backdrop-grayscale(0);
}
.backdrop-grayscale,
.focus\:backdrop-grayscale:focus,
.hover\:backdrop-grayscale:hover {
  @include sable.filter-backdrop-grayscale(100%);
}

$hueRotates: (
  0,
  15,
  30,
  60,
  90,
  180,
) !default;

@each $value in $hueRotates {
  .hue-rotate-#{$value},
  .focus\:hue-rotate-#{$value}:focus,
  .hover\:hue-rotate-#{$value}:hover {
    @include sable.filter-hue-rotate(#{$value}deg)
  }
  .backdrop-hue-rotate-#{$value},
  .focus\:backdrop-hue-rotate-#{$value}:focus,
  .hover\:backdrop-hue-rotate-#{$value}:hover {
    @include sable.filter-backdrop-hue-rotate(#{$value}deg);
  }
}

.invert-0,
.focus\:invert-0:focus,
.hover\:invert-0:hover {
  @include sable.filter-invert(0);
}
.invert,
.focus\:invert:focus,
.hover\:invert:hover{
  @include sable.filter-invert(100%);
}

.backdrop-invert-0,
.focus\:backdrop-invert-0:focus,
.hover\:backdrop-invert-0:hover {
  @include sable.filter-backdrop-invert(0);
}
.backdrop-invert,
.focus\:backdrop-invert:focus,
.hover\:backdrop-invert:hover{
  @include sable.filter-backdrop-invert(100%);
}

@for $i from 0 through 20 {
  $name: $i * 5;
  $value: $i * 0.05;
  .backdrop-opacity-#{$name},
  .focus\:backdrop-opacity-#{$name}:focus,
  .hover\:backdrop-opacity-#{$name}:hover {
    @include sable.filter-backdrop-filter(opacity($value));
  }
}

$saturates: (
  0,
  .5,
  1,
  1.5,
  2,
) !default;

@each $value in $saturates {
  $number: $value * 10;
  .saturate-#{$number},
  .focus\:saturate-#{$number}:focus,
  .hover\:saturate-#{$number}:hover {
    @include sable.filter-saturate($value)
  }
  .backdrop-saturate-#{$number},
  .focus\:backdrop-saturate-#{$number}:focus,
  .hover\:backdrop-saturate-#{$number}:hover {
    @include sable.filter-backdrop-saturate($value);
  }
}

.sepia-0,
.focus\:sepia-0:focus,
.hover\:sepia-0:hover {
  @include sable.filter-sepia(0);
}
.sepia,
.focus\:sepia:focus,
.hover\:sepia:hover{
  @include sable.filter-sepia(100%);
}

.backdrop-sepia-0,
.focus\:backdrop-sepia-0:focus,
.hover\:backdrop-sepia-0:hover {
  @include sable.filter-backdrop-sepia(0);
}
.backdrop-sepia,
.focus\:backdrop-sepia:focus,
.hover\:backdrop-sepia:hover{
  @include sable.filter-backdrop-sepia(100%);
}
